/**  openSpeak - The open source VoIP application
  *  Copyright (C) 2006 - 2007  openSpeak Team (http://openspeak-project.org)
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation; either version 2 of the License, or
  *  (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License along
  *  with this program; if not, write to the Free Software Foundation, Inc.,
  *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
  */

#ifndef __LIBOS_UDP_CONNECTION_H__
#define __LIBOS_UDP_CONNECTION_H__

#include "osLib.h"

namespace openSpeak
{

/** \struct Packet
 *	\brief Contains all necessary informations to parse an incomming packet
 *	
 *	The Packet struct contains all important informations needed to parse an incomming packet.
 *	It gets generated by the UDPConnection class when a packet arrives and is parsed by a callback function.
 */
struct Packet
{
 public:
	/** \brief The void constructor of the Packet struct */
    Packet(void) { }

	/** \brief The full constructor of the Packet struct
	 *	\param _type The type of the Packet
	 *	\param _data The data in the Packet
	 *	\param _sender The sender of the Packet
	 */
	Packet(unsigned char _type, std::string _data, sockaddr_in _sender = sockaddr_in()) { type = _type; data = _data; sender = _sender;}

	/** \brief The copyconstructor of the Packet struct */
    Packet(Packet &pkt) { *this = pkt; }

	/** \brief Implementation of the operator= for the Packet struct
	 * 	\param pkt The packet to compare it with
	 * 	\return The resulting packet
	 */
    Packet& operator=(const Packet &pkt) { type = pkt.type; data = pkt.data; sender = pkt.sender; return *this;}

    unsigned short type;	/**< The type of the Packet */
    std::string data;		/**< The content of the Packet */
    sockaddr_in sender;		/**< The sender of the Packet */
};

/** \brief A generic callback function used by the UDPConnection class */
typedef void (*CallbackFunction)(UDPConnection *, Packet *);

/** \brief A std::map to store CallbackFunctions */
typedef std::map<ushort, CallbackFunction> CallbackMap;

/** \brief A std::vector to store Listener */
typedef std::vector<Listener*> ListenerVector;


/** \class UDPConnection
 *	\brief Provides functions to create a server/client and communicate with other servers/clients
 *
 *	The UDPConnection class is basically a wrapper on the standard bsd socket implementations provided by the OS.
 *	It can act as a server or as a client depending on the constructor call and the used functions.
 */
class UDPConnection
{
  public:
	/** \brief The constructor of the UDPConnection class
	 *	\param _client Act as a client or as a server?
	 */
    UDPConnection(const bool _client = true);

	/** \brief The destructor of the UDPConnection class */
    ~UDPConnection(void);

	/** \brief Check if there is something to read/write from the connection
	 *	\return True if there is something to read/write
	 */
	bool select(void);

	/** \brief Process everything that needs to be read/written */
    void process(void);

	/** \brief Check if this is a client
	 *	\return True if it is a client
	 */
    bool isClient(void) { return mClient; }

	/** \brief Connect to a server (client only)
	 *	\param server The server url/ip to connect to
	 *	\param port The port of the server
	 *	\param nick The nick to use on the server
	 *	\param password The password on the server
	 */
    void connect(const std::string &server, const ushort port, const std::string &nick, const std::string &password = "");

	/** \brief Disconnect from the server (client only) */
    void disconnect(void);

	/** \brief Check if we're connected (client only)
	 *	\return True if we're connected
	 */
    bool isConnected(void);

	/** \brief Bind the server to the specified port (server only)
	 *	\param port The port to bind the server to
	 */
    void bind(const ushort port);

	/** \brief Close the port the server is binded to (server only) */
    void close(void);

	/** \brief Check if the server is bound to a port (server only)
	 *	\return True if the server is bound to a port
	 */
    bool isBound(void);

	/** \brief Put a packet into the queue (client)
	 *	\param pkt String containing all packet data and the type
	 */
    inline void send(const std::string &pkt) { mSendQueue.push( std::make_pair<std::string, sockaddr_in>( pkt, sockaddr_in() ) ); }

	/** \brief Put a packet into the queue (client)
	 *	\param out OutStream containing all packet data and the type
	 */
    inline void send(OutStream out) { mSendQueue.push(std::make_pair<std::string, sockaddr_in>(out.asString(), sockaddr_in())); }

	/** \brief Put a packet into the queue (server)
	 *	\param pkt String containing all packet data and the type
	 *	\param to The destination of the packet
	 */
    inline void send(const std::string &pkt, const sockaddr_in &to) { mSendQueue.push( std::make_pair<std::string, sockaddr_in>(pkt, to) ); }

	/** \brief Put a packet into the queue (server)
	 *	\param out OutStream containing all packet data and the type
	 *	\param to The destination of the packet
	 */
    inline void send(OutStream out, const sockaddr_in &to) { mSendQueue.push(std::make_pair(out.asString(), to)); }

	/** \brief Send the message immediately without checking select (client)
	 *	\param pkt String containing all packet data and the type
	 */
    inline void forceSend(const std::string &pkt) { sendAll(pkt); }

	/** \brief Send the message immediately without checking select (client)
	 *	\param out OutStream containing all packet data and the type
	 */
    inline void forceSend(OutStream out) { sendAll(out.asString()); }

	/** \brief Send the message immediately without checking select (server)
	 *	\param pkt String containing all packet data and the type
	 *	\param to The destination of the packet
	 */
	inline void forceSend(const std::string &pkt, const sockaddr_in &to) { sendAll(pkt, to); }

	/** \brief Send the message immediately without checking select (server)
	 *	\param out OutStream containing all packet data and the type
	 *	\param to The destination of the packet
	 */
	inline void forceSend(OutStream out, const sockaddr_in &to) { sendAll(out.asString(), to); }

	/** \brief Add a packet callback
	 *	\param type The type that triggers the function
	 *	\param function The function that gets called
	 */
    void addCallback(const ushort type, const CallbackFunction function);

	/** \brief Remove a packet callback
	 *	\param type The type that triggered that function
	 */
    void removeCallback(const ushort type);

	/** \brief Get the currently set password (client)
	 *	\return The current password
	 */
    inline std::string getPassword(void) { return mPassword; }

	/** \brief Set the password to a new value 
	 *	\param password The new password
	 */
    inline void setPassword(const std::string &password) { mPassword = password; }

	/** \brief Add a packet listener
	 *	\param list The Listener to add
	 */
    inline void addListener(Listener* list) { if (list) mListeners.push_back(list); }

	/** \brief Remove a packet listener
	 *	\param list The Listener to remove
	 */
    void removeListener(Listener *list);

 protected:
	/** \brief Sends all data through the socket (client)
	 *	\param pkt The packet to send
	 */
    void sendAll(const std::string &pkt);

	/** \brief Sends all data through the socket (server)
	 *	\param pkt The packet to send
	 *	\param to The destination of the packet
	 */
    void sendAll(const std::string &pkt, const sockaddr_in &to);

	/** \brief Parses incoming packets
	 *	\param pkt The incoming data
	 *	\param from The socket from which the data is coming from
	 */
    void onRecieve(const std::string &pkt, const sockaddr_in &from);

    SOCKET mSocket;														/**< The socket we're sending/reading to/from */
    fd_set mRead;														/**< The file descriptor set for reading */
	fd_set mWrite;														/**< The file descriptor set for writing */	
    bool mReadIt;														/**< Should we read from the socket? */
	bool mWriteIt;														/**< Should we write to the socket? */
    sockaddr_in mServer;												/**< The address of the server (client) */
    std::queue< std::pair < std::string, sockaddr_in > > mSendQueue;	/**< Queue with all messages to send */
    CallbackMap mCallbacks;												/**< All callbacks that got added */
    ListenerVector mListeners;											/**< All listeners registered */
    std::string mPassword;												/**< The password we might use sometimes */
    bool mConnected, mBound;											/**< Are we connected or bound to a port */
    bool mClient;														/**< Are we a client */
};

}

#endif
